﻿var _timer;
var _interval = 0;

// needed for update service
var GadgetID = 1;
var version = 1.2;

function loadMain() {
	with(document.body.style) {
		height = "173px";
        width = "130px";
	}
	Bg.src = "url(images/docked.png)";
	document.body.focus();

	try {
		System.Gadget.settingsUI = "settings.html";
	}
	catch (ex) {
		// running in browser, no System.Gadget namespace available
	}

	var min = getSetting('refresh');
	if(min == null || min < 1)
		min = 1;
	
	_interval = (60*min)*1000;
	Refresh();
	RefreshTimer();
}
function RefreshTimer() {
	_timer = setInterval(Refresh, _interval);
}
function test() {
	findDOM("GadgetMain").innerHTML = "start";
}
function changeVisible(oldDIV, newDIV) {
	hide(oldDIV);
	show(newDIV);
}
function additem(name, url, fullname) {
	try
	{
		url.replace('\\', '/');
	}
	catch (Exception)
	{
		url = null;
	}
	
	if(name.length > 0) {
		if(name.length > 18)
			name = name.substr(0, 15) + "...";

		if(url == null || url.length < 1) {
			return "<li class='project' style='list-style-image: url(\"../images/vs-unknown.gif\");'>" + name + "</li>";
		}
		else {
			return "<li class='project' style='list-style-image: url(\"../images/vs.gif\");'><a alt='"+fullname+"' href='javascript:void(0);' onclick='executeCommands(\"" + url + "\");'>" + name + "</a></li>";	
		}
	}
	else {
		return null;
	}
}
function Refresh() {
	var output = "";
	var counter = 0;
	var page = 0;
	var item;
	var pages=new Array();
	projects = GetRecentProjects().split('|SEP|');
	for (var n=0; n<projects.length; n++) {
		project = projects[n].split("#SEP#");
		name = project[0];
		url = project[1];

		item = additem(name, url, project[0]);
		if(item != null) {
			counter++;
			output = output + item;
		}
		
		if(counter == 6) {
			counter = 0;
			pages[page] = output;
			output = "";
			page++;
		}
		if(n==(projects.length-1)) {
			// end
			pages[page] = output;
			output = "";
		}
	}
	for (var i=0; i<pages.length; i++) {
		if(i==0) {
			output = output + "<div class='page' id='page_"+i+"'><ul>";
		}
		else {
			output = output + "<div class='page' id='page_"+i+"' style='display:none;'><ul>";
		}

		output = output + pages[i] + "</ul><div class='gadgetPages'>";

		output = output + "<table border='0'><tr>";

		if(i==0) {
			output = output + "<td height='100%'></td>";
		}
		else {
			output = output + "<td align='left' height='100%'><a href='javascript:changeVisible(\"page_"+(i)+"\", \"page_"+(i-1)+"\");'>&laquo; Prev</a></td>";
		}
		if(i==(pages.length-1)) {
			// no next
			output = output + "<td></td>";
		}
		else {
			output = output + "<td align='right'><a href='javascript:changeVisible(\"page_"+i+"\", \"page_"+(i+1)+"\");'>Next &raquo;</a></td>";
		}
		output = output + "</tr></table></div></div>";
	}
	findDOM("GadgetMain").innerHTML = output;	
	CheckforUpdate();
}
function executeCommands(parm) {
	var oShell = new ActiveXObject("Shell.Application");
	var toRun = "devenv.exe"
	oShell.ShellExecute(parm, "", "", "open", "1");
}
function getHTTPObject() {
    var xmlhttp = false;
    /*@cc_on @*/
    /*@if (@_jscript_version >= 5)
    try {
        xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
    }
    catch (e) {
        try {
            xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
        }
        catch (ee) {
            xmlhttp = false;
        }

    }
    @end @*/
    if (!xmlhttp && typeof XMLHttpRequest!='undefined')
        xmlhttp = new XMLHttpRequest();
    
    return xmlhttp;
}
function CheckforUpdate() {
	var xmlhttp = getHTTPObject();
	xmlhttp.open("GET", "http://manuel.manuelles.nl/gadgetUpdateService.php?gadgetID="+GadgetID+"&ran="+Math.random(),true);  
    xmlhttp.onreadystatechange = function() {
		if (xmlhttp.readyState == 4) {
			if (xmlhttp.status == 200) {
				if(xmlhttp.responseText > version) {
					// new version
					xmlhttp = getHTTPObject();
					xmlhttp.open("GET", "http://manuel.manuelles.nl/gadgetUpdateService.php?gadgetID="+GadgetID+"&ran="+Math.random()+"&needUpdate=true",true);  
					xmlhttp.onreadystatechange = function() {
						if (xmlhttp.readyState == 4) {
							if (xmlhttp.status == 200) {
								findDOM("GadgetMain").innerHTML = xmlhttp.responseText;
								_timer = null;
							}
						}
					};
					xmlhttp.send(null);
				}
			}
			//else { ehh offline maybe? a we'll let's ignore }
		}
	};
    xmlhttp.send(null);
}